#ifndef INCLUDED_BOOST_UTILITY
	#include <boost/utility.hpp>
	#define INCLUDED_BOOST_UTILITY
#endif
#ifndef INCLUDED_BOOST_TYPETRAITS
	#include <boost/type_traits.hpp>
	#define INCLUDED_BOOST_TYPETRAITS
#endif
#include "MyOperators.hpp"


class MyInt
    : boost::operators<MyInt>, boost::operators<MyInt, int>
{
    bool operator<(const MyInt& x) const;
    bool operator==(const MyInt& x) const;
    MyInt& operator+=(const MyInt& x);
    MyInt& operator-=(const MyInt& x);
    MyInt& operator*=(const MyInt& x);
    MyInt& operator/=(const MyInt& x);
    MyInt& operator%=(const MyInt& x);
    MyInt& operator|=(const MyInt& x);
    MyInt& operator&=(const MyInt& x);
    MyInt& operator^=(const MyInt& x);
    MyInt& operator++();
    MyInt& operator--();
    bool operator<(const int& x) const;
	bool operator==(const int& x) const;
	MyInt& operator+=(const int& x);
	MyInt& operator-=(const int& x);
	MyInt& operator*=(const int& x);
	MyInt& operator/=(const int& x);
	MyInt& operator%=(const int& x);
	MyInt& operator|=(const int& x);
	MyInt& operator&=(const int& x);
    MyInt& operator^=(const int& x);
};

class YourInt
    : boost::operators<YourInt>
{
    bool operator<(const YourInt& x) const;
    bool operator==(const YourInt& x) const;
    YourInt& operator+=(const YourInt& x);
    YourInt& operator-=(const YourInt& x);
    YourInt& operator*=(const YourInt& x);
    YourInt& operator/=(const YourInt& x);
    YourInt& operator%=(const YourInt& x);
    YourInt& operator|=(const YourInt& x);
    YourInt& operator&=(const YourInt& x);
    YourInt& operator^=(const YourInt& x);
    YourInt& operator++();
    YourInt& operator--();
};

template <class T>
typename boost::enable_if<boost::mpl::or_<boost::is_integral<T>, algocpw::is_operators<T> >, void >::type
test_operators()
{
	printf("This works, awesome");
}
int main()
{
	test_operators<int>();
	test_operators<YourInt>();
	test_operators<MyInt>();
}
